@NoWayTime 在 空气热物性参数为列表形式时报错:Energy -> temperature conversion failed to converge 中说:
您好,我在依据nist数据库中的物性参数修改物质的Cp和H后,也出现了这个问题,请问您是怎么解决的。
我的问题出在边界条件设置不合理,建议您可视化界面看一下出现异常的位置,再分析具体原因,有问题我们再沟通!
@NoWayTime 在 空气热物性参数为列表形式时报错:Energy -> temperature conversion failed to converge 中说:
您好,我在依据nist数据库中的物性参数修改物质的Cp和H后,也出现了这个问题,请问您是怎么解决的。
我的问题出在边界条件设置不合理,建议您可视化界面看一下出现异常的位置,再分析具体原因,有问题我们再沟通!
@yingqing 在 空气热物性参数为列表形式时报错:Energy -> temperature conversion failed to converge 中说:
@gzs20 您好,我也在尝试将热物性改为表的形式,但是我仅仅将rho修改成为列表查询,并没有将其他的热物性修改为列表查询。但是结果显示,我的类里面的H.(scalar p, scalar T)出现问题
我当初是边界条件不合理导致的,出现了一些异常高温点和高流速点,修改完就正常了,建议您parafoam看一下结果,观察问题出现在那个位置处;具体分析,是网格的问题还是边界条件的问题;
@李东岳 谢谢东岳老师
@李东岳 东岳老师,您好,请问您说的笔记的附录在哪里可以找到,告知一下,目前卡在了电势的求解这一步
老师,请教一下,不同相的交界面电势的边界条件采用的那种了
是的,李老师
这是并行计算文件,您方便了帮忙看一下问题出在哪里;
#!/bin/bash
cd ${0%/*} || exit 1 # Run from this directory
# Source PATO run functions
. $PATO_DIR/src/applications/utilities/runFunctions/RunFunctions
# Initialize the script
pato_init
# source OpenFOAM and PATO if darwin
if [ "$(uname)" = "Darwin" ]; then
source $FOAM_ETC/bashrc
source $PATO_DIR/bashrc
fi
# Check number of processors
if [ -z $1 ];
then
echo "error: correct usage = ./Allrun_parallel <number_processors>"
exit 1
fi
re='^[0-9]+$'
if ! [[ $1 =~ $re ]] ; then
echo "error: First argument is not a number" >&2
exit 1
fi
NPROCESSOR=$1
# sed command
if [ "$(uname)" = "Darwin" ]; then
sed_cmd=gsed
else
sed_cmd=sed
fi
# change the decomposeParDict files
$sed_cmd -i 's/numberOfSubdomains \+[0-9]*;/numberOfSubdomains '"$NPROCESSOR"';/g' system/air/decomposeParDict
$sed_cmd -i 's/numberOfSubdomains \+[0-9]*;/numberOfSubdomains '"$NPROCESSOR"';/g' system/core/decomposeParDict
$sed_cmd -i 's/numberOfSubdomains \+[0-9]*;/numberOfSubdomains '"$NPROCESSOR"';/g' system/upCore/decomposeParDict
$sed_cmd -i 's/numberOfSubdomains \+[0-9]*;/numberOfSubdomains '"$NPROCESSOR"';/g' system/carbon/decomposeParDict
# create volume fields (first time step : 50 s)
#scp -r origin.0 50
#scp -r constant/porousMat/copy.polyMesh constant/porousMat/polyMesh
#scp -r constant/subMat1/copy.polyMesh constant/subMat1/polyMesh
rm log.PATOx
count=ls -1 processor* 2>/dev/null | wc -l
if [ $count != 0 ];
then
rm -rf processor*
fi
# decompose the mesh
#setFields -region air
decomposePar -allRegions
#run case
#/usr/bin/mpirun -np $NPROCESSOR PATOx -parallel
/usr/bin/mpirun -np $NPROCESSOR PATOx -parallel
#runParallel $(getApplication)
# 3D post-processing
reconstructPar -allRegions
# paraFoam -builtin
# probe scalar fields (temperature, pressure, density, etc) at desired locations - chosen in system/sampleDict
#postProcess -func sampleDict -region porousMat
# grab probed fields and copy them into files
# postProcessTime <dictName> <regionName> <inputFileName> <outputFileName>
#postProcessTime sampleDict porousMat surfacePatch_Ta.xy output/plot_surfacePatch_Ta
这是并行计算0.02后的空气电势分布结果;
这是串行计算0.02后电势分布结果;
问题已解决,有相似的问题可以咨询我
我在运行过程中将空气的热物性参数从常数形式修改后列表形式后,运行报错。(仅仅改变了 thermophysicalProperties的内容)
这是空气的热物性参数为列表形式(具体的文件形式见后文)时所报的错:
Region: air Courant Number mean: 0.0222588 max: 0.507774
runTime = 5e-06 s Time step = 1e-07 s
Solving for fluid region air
diagonal: Solving for rho, Initial residual = 0, Final residual = 0, No Iterations 0
DILUPBiCG: Solving for Ux, Initial residual = 0.246745, Final residual = 3.40373e-07, No Iterations 2
DILUPBiCG: Solving for Uy, Initial residual = 0.241797, Final residual = 4.05735e-07, No Iterations 2
DILUPBiCG: Solving for Uz, Initial residual = 0.241981, Final residual = 3.98148e-07, No Iterations 2
DILUPBiCG: Solving for h, Initial residual = 0.554675, Final residual = 1.20099e-07, No Iterations 2
From function Foam::scalar Foam::species::thermo<Thermo, Type>::T(Foam::scalar, Foam::scalar, Foam::scalar, Foam::scalar (Foam::species::thermo<Thermo, Type>::*)(Foam::scalar, Foam::scalar) const, Foam::scalar (Foam::species::thermo<Thermo, Type>::*)(Foam::scalar, Foam::scalar) const, Foam::scalar (Foam::species::thermo<Thermo, Type>::*)(Foam::scalar) const, bool) const [with Thermo = Foam::hTabularThermo<Foam::Rhotabular<Foam::specie> >; Type = Foam::sensibleEnthalpy; Foam::scalar = double; Foam::species::thermo<Thermo, Type> = Foam::species::thermo<Foam::hTabularThermo<Foam::Rhotabular<Foam::specie> >, Foam::sensibleEnthalpy>]
in file /opt/openfoam7/src/thermophysicalModels/specie/lnInclude/thermoI.H at line 70
Energy -> temperature conversion failed to converge:******
iter Test e/h Cv/p Tnew
0 6164.35 2.58306e+07 17334.9 7907.88
1 7907.88 4.11091e+07 2815.95 13215.3
2 13215.3 5.2184e+07 2020.67 15130.7
3 15130.7 5.57735e+07 2025.29 15269.5
4 15269.5 5.57735e+07 2025.29 15408.2
5 15408.2 5.57735e+07 2025.29 15547
6 15547 5.57735e+07 2025.29 15685.7
7 15685.7 5.57735e+07 2025.29 15824.5
8 15824.5 5.57735e+07 2025.29 15963.3
9 15963.3 5.57735e+07 2025.29 16102
10 16102 5.57735e+07 2025.29 16240.8
11 16240.8 5.57735e+07 2025.29 16379.5
12 16379.5 5.57735e+07 2025.29 16518.3
13 16518.3 5.57735e+07 2025.29 16657
14 16657 5.57735e+07 2025.29 16795.8
15 16795.8 5.57735e+07 2025.29 16934.5
16 16934.5 5.57735e+07 2025.29 17073.3
17 17073.3 5.57735e+07 2025.29 17212
18 17212 5.57735e+07 2025.29 17350.8
19 17350.8 5.57735e+07 2025.29 17489.6
20 17489.6 5.57735e+07 2025.29 17628.3
21 17628.3 5.57735e+07 2025.29 17767.1
22 17767.1 5.57735e+07 2025.29 17905.8
23 17905.8 5.57735e+07 2025.29 18044.6
24 18044.6 5.57735e+07 2025.29 18183.3
25 18183.3 5.57735e+07 2025.29 18322.1
26 18322.1 5.57735e+07 2025.29 18460.8
27 18460.8 5.57735e+07 2025.29 18599.6
28 18599.6 5.57735e+07 2025.29 18738.3
29 18738.3 5.57735e+07 2025.29 18877.1
30 18877.1 5.57735e+07 2025.29 19015.8
31 19015.8 5.57735e+07 2025.29 19154.6
32 19154.6 5.57735e+07 2025.29 19293.4
33 19293.4 5.57735e+07 2025.29 19432.1
34 19432.1 5.57735e+07 2025.29 19570.9
35 19570.9 5.57735e+07 2025.29 19709.6
36 19709.6 5.57735e+07 2025.29 19848.4
37 19848.4 5.57735e+07 2025.29 19987.1
38 19987.1 5.57735e+07 2025.29 20125.9
39 20125.9 5.57735e+07 2025.29 20264.6
40 20264.6 5.57735e+07 2025.29 20403.4
41 20403.4 5.57735e+07 2025.29 20542.1
42 20542.1 5.57735e+07 2025.29 20680.9
43 20680.9 5.57735e+07 2025.29 20819.6
44 20819.6 5.57735e+07 2025.29 20958.4
45 20958.4 5.57735e+07 2025.29 21097.2
46 21097.2 5.57735e+07 2025.29 21235.9
47 21235.9 5.57735e+07 2025.29 21374.7
48 21374.7 5.57735e+07 2025.29 21513.4
49 21513.4 5.57735e+07 2025.29 21652.2
50 21652.2 5.57735e+07 2025.29 21790.9
51 21790.9 5.57735e+07 2025.29 21929.7
52 21929.7 5.57735e+07 2025.29 22068.4
53 22068.4 5.57735e+07 2025.29 22207.2
54 22207.2 5.57735e+07 2025.29 22345.9
55 22345.9 5.57735e+07 2025.29 22484.7
56 22484.7 5.57735e+07 2025.29 22623.4
57 22623.4 5.57735e+07 2025.29 22762.2
58 22762.2 5.57735e+07 2025.29 22901
59 22901 5.57735e+07 2025.29 23039.7
60 23039.7 5.57735e+07 2025.29 23178.5
61 23178.5 5.57735e+07 2025.29 23317.2
62 23317.2 5.57735e+07 2025.29 23456
63 23456 5.57735e+07 2025.29 23594.7
64 23594.7 5.57735e+07 2025.29 23733.5
65 23733.5 5.57735e+07 2025.29 23872.2
66 23872.2 5.57735e+07 2025.29 24011
67 24011 5.57735e+07 2025.29 24149.7
68 24149.7 5.57735e+07 2025.29 24288.5
69 24288.5 5.57735e+07 2025.29 24427.2
70 24427.2 5.57735e+07 2025.29 24566
71 24566 5.57735e+07 2025.29 24704.8
72 24704.8 5.57735e+07 2025.29 24843.5
73 24843.5 5.57735e+07 2025.29 24982.3
74 24982.3 5.57735e+07 2025.29 25121
75 25121 5.57735e+07 2025.29 25259.8
76 25259.8 5.57735e+07 2025.29 25398.5
77 25398.5 5.57735e+07 2025.29 25537.3
78 25537.3 5.57735e+07 2025.29 25676
79 25676 5.57735e+07 2025.29 25814.8
80 25814.8 5.57735e+07 2025.29 25953.5
81 25953.5 5.57735e+07 2025.29 26092.3
82 26092.3 5.57735e+07 2025.29 26231
83 26231 5.57735e+07 2025.29 26369.8
84 26369.8 5.57735e+07 2025.29 26508.6
85 26508.6 5.57735e+07 2025.29 26647.3
86 26647.3 5.57735e+07 2025.29 26786.1
87 26786.1 5.57735e+07 2025.29 26924.8
88 26924.8 5.57735e+07 2025.29 27063.6
89 27063.6 5.57735e+07 2025.29 27202.3
90 27202.3 5.57735e+07 2025.29 27341.1
91 27341.1 5.57735e+07 2025.29 27479.8
92 27479.8 5.57735e+07 2025.29 27618.6
93 27618.6 5.57735e+07 2025.29 27757.3
94 27757.3 5.57735e+07 2025.29 27896.1
95 27896.1 5.57735e+07 2025.29 28034.8
96 28034.8 5.57735e+07 2025.29 28173.6
97 28173.6 5.57735e+07 2025.29 28312.4
98 28312.4 5.57735e+07 2025.29 28451.1
99 28451.1 5.57735e+07 2025.29 28589.9
100 28589.9 5.57735e+07 2025.29 28728.6
101 28728.6 5.57735e+07 2025.29 28867.4
--> FOAM FATAL ERROR:
Maximum number of iterations exceeded: 100
**空气热物性参数(列表形式)的文件内容:**
FoamFile {
version 2.0;
format ascii;
class dictionary;
location "constant/bottomAir";
object thermophysicalProperties;
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
thermoType {
type heRhoThermo;
mixture pureMixture;
transport tabular;
thermo hTabular;
equationOfState Rhotabular;
specie specie;
energy sensibleEnthalpy;
}
mixture {
specie
{
nMoles 1;
molWeight 28.96;
}
equationOfState
{
file "$PATO_DIR/data/Fluids/fluidPropertyTable/Air5/Equilibrium/densityTable";
outOfBounds clamp;
}
thermodynamics
{
Hf 0;
Cp
{
file "$PATO_DIR/data/Fluids/fluidPropertyTable/Air5/Equilibrium/cpTable";
outOfBounds clamp;
}
h
{
file "$PATO_DIR/data/Fluids/fluidPropertyTable/Air5/Equilibrium/hTable";
outOfBounds clamp;
}
}
transport
{
mu
{
file "$PATO_DIR/data/Fluids/fluidPropertyTable/Air5/Equilibrium/muTable";
outOfBounds clamp;
}
kappa
{
file "$PATO_DIR/data/Fluids/fluidPropertyTable/Air5/Equilibrium/kappaTable";
outOfBounds clamp;
}
}
}
**空气热物性参数(常数形式)的文件内容**
FoamFile {
version 2.0;
format ascii;
class dictionary;
location "constant/hotFlow";
object thermophysicalProperties;
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
thermoType {
type heRhoThermo;
mixture pureMixture;
transport const;
thermo hConst;
equationOfState perfectGas;
specie specie;
energy sensibleEnthalpy;
}
mixture {
specie
{
nMoles 1;
molWeight 28.9;
}
thermodynamics
{
Cp 1000;
Hf 0;
}
transport
{
mu 1.8e-05;
Pr 0.7;
}
}